# python

如项目需要在 python3.8 环境下开发，可以使用以下方式：

```
docker run --rm -it -v /workspace:/app python:3.8 /bin/bash

```

python环境编译较慢，为此最佳的方式 pull 镜像


## 集成部署

前端vue项目静态打包到 static 目录

## 前后端分离部署方案

部署的方法很多

## nginx + 前后分离

前端静态打包dist，nginx指定root目录即可，对于/api 请求，反向代理转发到 proxy_pass http://127.0.0.1:9999

## 前端打包 dist，放到后端 dist 目录

前后端合并，适合打包成二进制交付部署

## docker 部署

基于 nginx + 前后分离 模式，后端打包 jiamboy/fastapi 镜像，镜像中安装 nginx，多阶段构建镜像，把前端dist复制到后端镜像。启动命令：先启动nginx（后台自动运行），然后启动python app.py

## docker-compose 部署

前端 + nginx 启动一个容器，后端 python.py 启动一个容器，数据库，redis等分别启动一个容器。


```
FROM python:3.8
#FROM node:14
# FROM mcr.microsoft.com/devcontainers/universal:2

# install vscode and extension
RUN curl -fsSL https://code-server.dev/install.sh | sh &&\
    code-server --install-extension redhat.vscode-yaml &&\
    code-server --install-extension orta.vscode-jest &&\
    code-server --install-extension dbaeumer.vscode-eslint &&\
    code-server --install-extension eamodio.gitlens &&\
    echo done

#     code-server  --install-extension ms-python.python &&\  很慢，无法安装
# 安装 ssh 服务，用于支持 Vscode 客户端通过 Remote-SSH 访问开发环境
# （如果需要支持客户端打开远程开发环境可安装）
RUN apt-get update && apt-get install -y wget unzip openssh-server

# 指定字符集支持命令行输入中文（根据需要选择字符集）
ENV LANG C.UTF-8
ENV LANGUAGE C.UTF-8
```



