# coding.net

coding 提供两个开发环境：

* 云原生开发环境
* cloudstudio

前者免费 160 小时/月，后者免费 3000 分钟 = 50小时/月。


## 远程开发

在本地通过 repo_sync tools v1.12，快速创建 coding.net 项目，项目推到云端，然后在云端开发。

添加 `.coding-ci.yml` 以及 `.ide/Dockerfile`配置文件:

`.coding-ci.yml`
```
$:
  api_trigger_vscode:
    clouddev:
      runner:
        cpus: 4
      docker:
        cpus: 4
        build: .ide/Dockerfile
        image: codingci/default-env:latest
      services:
        - vscode
        - docker
      stages:
        - name: 开启云原生远程开发
          type: vscode:go

```

为了节省 cpu 资源，这里 node/php 开发等配置 cpu 为1 即可，app开发等配置cpu 4-8 个。

`.ide/Dockerfile`

```
FROM sift-docker.pkg.coding.net/flutter-team/dev-container/dev-allinone:1.0.11-flutter
```

这个镜像源码在 flutter\.ide\Dockerfile-Allinone-flutter 中， 包含了 flutter, node, php, go, python, java, rust, ruby, c/c++, .net, dart 等开发环境，方便快速编译项目。

vscode 打开btn 跳转：
```
vscode://vscode-remote/ssh-remote+coding-ci-nro-1hus7gapn-001%233f93b6e9-557a-4232-b981-9613dac9c9e1-8q8@ci.coding.net:2201/workspace/
```



## cloudstudio

cloudstudio 是独立的产品，一般都是基于模板快速新建开发环境，当然也可以手动选择项目新建环境。只能选择系统开发环境。主要用来做数据分析。




## ci/cd

coding 提供 ci/cd 服务，可以在项目中配置 ci/cd，自动化构建，测试，部署。








